# -*- coding: utf-8 -*-
from setuphelpers import *


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    url = "https://wingetgui.com/apps/Dell-DisplayManager"

    print("URL used is: %s" % url)

    # Getting the download page link
    for get_url in bs_find_all(
        url,
        "a",
        attribute="target",
        value="_blank",
        proxies=proxies,
    ):
        if "https://dl.dell.com" in get_url.string:
            download_url = get_url.string
            latest_bin = download_url.split("/")[-1]
            break

    # Getting the version
    version = bs_find(
        url,
        "h3",
        proxies=proxies,
    ).text.split(
        "Download Links For Version "
    )[-1]

    # Downloading latest binaries
    print("Latest %s version is: %s" % (control.name, version))
    print("Download URL is: %s" % download_url)
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)
    else:
        print("Binary is present: %s" % latest_bin)

    # Checking version from file
    version_from_file = get_version_from_binary(latest_bin)
    if Version(version_from_file, 4) != Version(version, 4) and version_from_file != "":
        print(
            "Changing version to the version number of the binary (from: %s to: %s)"
            % (version, version_from_file)
        )
        # os.rename(latest_bin, latest_bin.replace(version, version_from_file))
        version = version_from_file
    else:
        print("Binary file version corresponds to online version")

    # Changing version of the package
    if Version(version, 4) > Version(control.get_software_version(), 4):
        print(
            "Software version updated (from: %s to: %s)"
            % (control.get_software_version(), Version(version))
        )
        package_updated = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.set_software_version(version)
    control.save_control_to_wapt()

    # Validating or not update-package-sources
    return package_updated

    # # Changing version of the package and validating update-package-sources
    # return complete_control_version(control, version)
